program kostra;

uses
  SysUtils,
  Windows,
  Messages,
  hlavni in 'hlavni.pas',
  XEngine in 'XEngine.pas',
  XSound in 'XSound.pas',
  XConsts in 'XConsts.pas',
  XMenu in 'XMenu.pas';

procedure Clean;
 begin
  if XInput<>nil then begin XInput.Free; XInput:=nil; end;
  if XDraw<>nil then begin XDraw.Free; XDraw:=nil;end;
  if XSoundSystem<>nil then begin XSoundSystem.Free; XSoundSystem:=nil; end;
 end;

procedure DestroyThisWindow;
 begin
  if HandleOkna<>0 then begin DestroyWindow(HandleOkna); HandleOkna:=0;end;
 end;


 {osetreni zprav od Woken}
 function WndProc(hwnd:HWND; uMsg:UINT; wParam:WPARAM; lParam:LPARAM):LRESULT; stdcall;
 begin
  case uMsg of
   WM_SETCURSOR: SetCursor(0);
   WM_DESTROY: begin PostQuitMessage(0); result:=0; exit; end;
   WM_ACTIVATE:
    begin
     if (wParam=WA_ACTIVE)or(wParam=WA_CLICKACTIVE)then
      begin
       if XInput<>nil then XInput.RestoreAll;
       Aktivni:=true;
      end;
     if (wParam=WA_INACTIVE)then Aktivni:=false;
    end;
   WM_SYSCOMMAND:
    case wParam of
     SC_MOVE,SC_SIZE,SC_MAXIMIZE,SC_KEYMENU,SC_MONITORPOWER:
      begin result:=1;exit;end;
    end;
  end;
  Result:=DefWindowProc(hwnd,uMsg,wParam,lParam);
 end;



 function RegistraceOkna:boolean;
  var wc: TWndClass; {typ okna, ktery si zaregistruju}
 begin
  wc.lpszClassName:=WNDCLASS_NAME;
  wc.lpfnWndProc:=@WndProc;
  wc.style:=CS_VREDRAW+CS_HREDRAW;
  wc.hInstance:=hInstance;
  wc.hIcon:=0;
  wc.hCursor:=0;
  wc.hbrBackground:=GetStockObject(BLACK_BRUSH);
  wc.lpszMenuName:=nil;
  wc.cbClsExtra:= 0;
  wc.cbWndExtra:= 0;
  result:=RegisterClass(wc)<>0;
 end;


 function VytvoreniOkna:boolean;
 begin
  HandleOkna:=CreateWindow(WNDCLASS_NAME,APP_NAME,0,0,0,320,200,
                           {GetDesktopWindow}0,0, hInstance, nil);
  result:=HandleOkna<>0;
 end;


 
begin
if not RegistraceOkna then Halt(1);
if not VytvoreniOkna then Halt(1);
ShowWindow(HandleOkna, SW_SHOWDEFAULT);
UpdateWindow(HandleOkna);

XDraw:=TXDraw.Create(RESX,RESY,BPP,HandleOkna);
if XDraw.Error<>'' then
 begin
  Clean;
  MessageBox(HandleOkna,PChar(XDraw.Error),'Chyba',
             MB_OK+MB_ICONERROR+MB_APPLMODAL+MB_SETFOREGROUND);
  DestroyThisWindow; Exit;
 end;

XInput:=TXInput.Create(XDraw,HandleOkna);
if XInput.Error<>'' then
 begin
  Clean;
  MessageBox(HandleOkna,PChar(XInput.Error),'Chyba',
             MB_OK+MB_ICONERROR+MB_APPLMODAL+MB_SETFOREGROUND);
  DestroyThisWindow; Exit;
 end;

XSoundSystem:=TXSoundSystem.Create(X_FM_MIXRATE,X_FM_CHANNELS,HandleOkna);
if XSoundSystem.Error<>'' then
 begin
  Clean;
  MessageBox(HandleOkna,PChar(XSoundSystem.Error),'Chyba',
             MB_OK+MB_ICONERROR+MB_APPLMODAL+MB_SETFOREGROUND);
  DestroyThisWindow; exit;
 end;                  

INICIALIZACE;


repeat
if PeekMessage(msg,0,0,0,PM_NOREMOVE) then
 begin
  if not GetMessage(msg,0,0,0) then
   skoncit:=true
  else
   begin
    TranslateMessage(msg);
    DispatchMessage(msg);
   end;
 end
else
 begin
  if Aktivni then TAKT;
 end
until skoncit;



ZNICENI;
Clean;
DestroyThisWindow;
end.
